Player = {
	x = 	30,
	y = 0300,
	height = 32,
	width = 32,
	vx = 0,
	vy = 0,
	dx = 0,
	dy = 0,
	state = "standing",
	facing = 'right',
	speed = 300,
	jumpSpeed = 10,
	onGround = false,
	onLadder = false,
	health = 3,
}

function Player.load()
		player  = entity.new(32,32,20,20,atlMap,select(2,next(atlMap.layers)))	
		gravity = 50
		
		animation = SpriteAnimation:new("Player/PlayerSprite.png", 32, 32, 4, 4)
		animation:load(120)
		
		heartTileset = love.graphics.newImage('Player/hearts.png')
		
		heartQuad = {
			{0,0}, --full
			{0,16} --empty
		}
		Hearts = {}
		for i,info in ipairs(heartQuad) do
			Hearts[i] = love.graphics.newQuad(info[1], info[2], 16, 16, 48, 16)
		end
end

function Player.update(dt)

	if love.keyboard.isDown("d") then
		Player.state = "runningRight"
		Player.facing = 'right'
		Player.vx = Player.speed * dt
		
		animation:flip(false,false)
		animation:switch(2, 4, 120)
	elseif love.keyboard.isDown("a") then
		Player.state = "runningLeft"
		Player.facing = 'left'
		Player.vx = -Player.speed * dt
		
		animation:flip(true,false)
		animation:switch(2, 4, 120)
	else 
		Player.state = "standing"
		Player.vx = 0
		animation:switch(1, 4, 200)
	end
	
	if love.keyboard.isDown(" ") then
		if Player.onGround == true then
			Player.vy = -Player.jumpSpeed
			Player.onGround = false
			
			
		end
	end
	

	
	if Player.onLadder == true then
		Player.vy = -Player.speed * dt
	end
		
	
	Player.vy = Player.vy + (dt*gravity)
			
	Player.dx = Player.vx
	Player.dy = Player.vy + (dt * gravity)

	if Player.vy > 0 then
		
	elseif Player.vy < 0 then
		Player.state = "jumping"
		animation:switch(3, 1, 300)
	elseif Player.vy == 0 then
		Player.state = "standing"	
	end
	
	
animation:update(dt)
end

function Player.draw()

	animation:draw(realPlayerx - 8, realPlayery - (Player.height/2 - 10))

	--player:draw("fill")
	player:move(Player.dx,Player.dy)

end