collision = {}

function collision.load()
	knifeHit = false
	
function player:isResolvable(side,tile,gx,gy)
		-- all the following tile properties can be set in Tiled
		-- in this demo, I gave each tile a "type" value to differentiate them
		local tp = tile.properties
		
		if tp.type  == 'solid' then
			-- set to ground state if bottom sensor
			if side == 'bottom' then Player.onGround = true; Player.vy = 0 end
			if side == 'top' then Player.vy = 5 end
			return true
		end
		
		if tp.type == 'ladder' then
			Player.onLadder = true
		else 
			Player.onLadder = false
		end
		
		if tp.type == 'ladderTop' then
			Player.vy = -Player.jumpSpeed
		end
		
		-- A TILE CAN HAVE BOTH TYPES OF HEIGHT MAPS AT THE SAME TIME!
		
		-- slope checks:
		-- we give floor slopes vertical height maps
		-- vertical height maps adjust an object's position vertically
		if  (tp.type == 'slopeUp' or tp.type == 'slopeDown') and  side == 'bottom' then 
			-- change to ground state
			Player.vy          = 0
			Player.onGround  = true
			return true 
		end
		
		-- we give ceiling slopes horizontal height maps		
		-- horizontal height maps adjust an object's position horizontally
		if tp.type == 'ceilingDown' and side == 'right' then 
			return true 
		end
		
		if tp.type == 'ceilingUp' and side == 'left' then 
			return true 
		end
	end

-- set up heightmaps
	-- 45 degree angle:
	local h = {}; local h2 = {}
	for i = 1,32 do
		h[i] = i
	end
	for i = 1,32 do
		h2[i] = 33-i
	end
	
	-- assign height maps to approriate tiles
	for id,tile in pairs(atlMap.tiles) do
		local tp = tile.properties
		if tp.type == 'slopeUp' then
			tp.verticalHeightMap   = h
		elseif tp.type == 'slopeDown' then
			tp.verticalHeightMap   = h2
		elseif tp.type == 'ceilingUp' then
			tp.horizontalHeightMap = h2
		elseif tp.type == 'ceilingDown' then
			tp.horizontalHeightMap = h2
		end
	end
	
	function ghost:isResolvable(side,tile,gx,gy)
		local tp = tile.properties
		
		if tp.type  == 'blocker' then
				Ghost.hit = true
			return true
		end

	end
	
	function ghost2:isResolvable(side,tile,gx,gy)
		local tp = tile.properties
		
		if tp.type  == 'blocker' then
				Ghost.hit = true
			return true
		end

	end
	
	function ghost3:isResolvable(side,tile,gx,gy)
		local tp = tile.properties
		
		if tp.type  == 'blocker' then
				Ghost.hit = true
			return true
		end

	end
end



function collision.update()
	
	for i,v in ipairs(Enemies) do 
		if Sword.swung == true then
			if Player.facing == 'right' then
		  		if CheckCollision(realPlayerx + Player.width/2,realPlayery + Player.height/2 - 5,Sword.width, Sword.height, v.x,v.y,v.width,v.height) then
			 	  table.remove(Enemies,i)
			 	  collided = true
			 	 end
			 elseif Player.facing == 'left' then
		  		if CheckCollision(realPlayerx - Player.width,realPlayery + Player.height/2 - 5,Sword.width, Sword.height, v.x,v.y,v.width,v.height) then
			 	  table.remove(Enemies,i)
			 	  collided = true
			 	end			 
		    end
		 end -- end Sword.swung
		 
		for ii, vv in ipairs(knife) do 
			if checkCircularCollision(vv.x, vv.y, v.x, v.y, 8, 1) then
				table.remove(Enemies,i)
				table.remove(knife, ii)
			end
		end--end knife FOR
		
		if CheckCollision(realPlayerx,realPlayery,Player.width - 10,Player.height - 4, v.x,v.y,v.width,v.height) then
			Player.health = Player.health - 1
			table.remove(Enemies,i)
		end
		
	end -- end Enemies1
		
	for i,v in ipairs(Enemies2) do 
		if Sword.swung == true then
			if Player.facing == 'right' then
		  		if CheckCollision(realPlayerx + Player.width/2,realPlayery + Player.height/2 - 5,Sword.width, Sword.height, v.x,v.y,v.width,v.height) then
			 	  table.remove(Enemies2,i)
			 	  collided = true
			 	 end
			 elseif Player.facing == 'left' then
		  		if CheckCollision(realPlayerx - Player.width,realPlayery + Player.height/2 - 5,Sword.width, Sword.height, v.x,v.y,v.width,v.height) then
			 	  table.remove(Enemies2,i)
			 	  collided = true
			 	end			 
		    end
		 end -- end Sword.swung
		 
		for ii, vv in ipairs(knife) do 
			if checkCircularCollision(vv.x, vv.y, v.x, v.y, 8, 1) then
				table.remove(Enemies2,i)
				table.remove(knife, ii)
			end
		end
		
		if CheckCollision(realPlayerx,realPlayery,Player.width - 10,Player.height - 4, v.x,v.y,v.width,v.height) then
			Player.health = Player.health - 1
			table.remove(Enemies2,i)
		end
	end
		
	for i,v in ipairs(Enemies3) do 
		if Sword.swung == true then
			if Player.facing == 'right' then
		  		if CheckCollision(realPlayerx + Player.width/2,realPlayery + Player.height/2 - 5,Sword.width, Sword.height, v.x,v.y,v.width,v.height) then
			 	  table.remove(Enemies3,i)
			 	  collided = true
			 	 end
			 elseif Player.facing == 'left' then
		  		if CheckCollision(realPlayerx - Player.width,realPlayery + Player.height/2 - 5,Sword.width, Sword.height, v.x,v.y,v.width,v.height) then
			 	  table.remove(Enemies3,i)
			 	  collided = true
			 	end			 
		    end
		 end -- end Sword.swung
		 
		for ii, vv in ipairs(knife) do 
			if checkCircularCollision(vv.x, vv.y, v.x, v.y, 8, 1) then
				table.remove(Enemies3,i)
				table.remove(knife, ii)
			end
		end
		
		if CheckCollision(realPlayerx,realPlayery,Player.width - 10,Player.height - 4, v.x,v.y,v.width,v.height) then
			Player.health = Player.health - 1
			table.remove(Enemies3,i)
		end
	end
		

	
	
	
end