	require 'conf'
	require 'Player/player'
	require 'collision'
	require 'Player/sword'
	require 'Player/SpriteAnimation'
	require 'camera'
	require 'ghost'
	require 'Player/knife'
	
function love.load()
-- Global Vars
 	width = love.graphics.getWidth()
	height = love.graphics.getHeight()
	
-- load libs and map
	atl     = require 'libs.ATL'
	atlMap  = atl.Loader.load 'map/map.tmx'
	entity  = require 'libs.atc.atc'
	atlMap:setDrawRange(0, 0, atlMap.width * atlMap.tileWidth, atlMap.height * atlMap.tileHeight)
	
--Camera Bounds
	camera:setBounds(0, 0, atlMap.width * atlMap.tileWidth - width, atlMap.height * atlMap.tileHeight - height)

	realPlayerx = 0
	realPlayery = 0

	Player.load()
	addGhost1()
	addGhost2()
	addGhost3()
	Knife.load()
	
	collision.load()
	
	
	
end

function love.update(dt)
	ghostChase(dt)
	realPlayerx = math.floor(player.x)
	realPlayery = player.y

	
	Player.update(dt)
	Sword.update(dt)
	Knife.throw(dt)
	collision.update()
	
	camera:setPosition(math.floor(realPlayerx - width / 2), math.floor(realPlayery - height / 2))

end

function love.draw()

	camera:set()
-- draw in camera
	atlMap:draw()
	Player.draw()
	Sword.draw()
	Knife.draw()
	Ghost.draw()
	
	 camera:unset()
--draw outside camera

	for i = 1, Player.health do
		love.graphics.drawq(heartTileset, Hearts[1], (width/2 - 48) + (16 * i), 10)
	end

	--debug
	love.graphics.print("Player X:"..realPlayerx, 20, 10)
	love.graphics.print("Player Y :"..realPlayery, 20, 25)
	love.graphics.print("State:"..Player.state, 20, 40)
	love.graphics.print("facing: "..Player.facing, 20, 55)
	love.graphics.print("Player.vy: "..Player.vy, 20, 70)
	love.graphics.print("Knife Hit: "..tostring(knifeHit), 20, 85)

end

-- Global Functions
function math.clamp(x, min, max)
    return x < min and min or (x > max and max or x)
end

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function checkCircularCollision(ax, ay, bx, by, ar, br)
    local dx = bx - ax
    local dy = by - ay
    local dist = math.sqrt(dx * dx + dy * dy)
    return dist < ar + br
end